pci = {}
function DEC_HEX(IN)
	OUT = string.format("%x", IN or 0):upper()
	while #OUT<4 do OUT = "0"..OUT end
	return OUT
end
pci["pci-00"] = function(i, a) -- 00 nop -- : do nothing
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 00 nop "..DEC_HEX(a))
end
pci["pci-01"] = function(i, a) -- 01 val #A : copy #A to %R
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 01 get #"..DEC_HEX(a))
	r = peek(i, o+2)
	r.c = a
	poke(i, o+2, r)
end
pci["pci-02"] = function(i, a) -- 02 get &A : copy @A to %R (address, signal included)
	local m = peek(i, a)
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 02 get @"..DEC_HEX(a))
	poke(i, o+2,m)
end
pci["pci-03"] = function(i, a) -- 03 get @A : copy &A to %R (pointer, signal included)
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 03 get &"..DEC_HEX(a))
	p = peek(i, a)
	poke(i, o+2, peek(i, p.c))
end

pci["pci-04"] = function(i, a) -- 04 set &A : copy %R to &A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 04 set @"..DEC_HEX(a))
	poke(i, a, peek(i, o+2))
end
pci["pci-05"] = function(i, a) -- 05 set @A : copy %R to @A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 05 set &"..DEC_HEX(a))
	p = peek(i, a)
	poke(i, p.c, peek(i, o+2))
end
pci["pci-06"] = function(i, a) -- 06 swp @A : swap %R with @A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 05 set &"..DEC_HEX(a))
	m = peek(i, a)
	r = peek(i, o+2)
	poke(i, a, r)
	poke(i, o+2, m)
end
pci["pci-07"] = function(i, a) -- 07 swp &A : swap %R with &A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 05 set &"..DEC_HEX(a))
	p = peek(i, a)
	m = peek(i, p.c)
	r = peek(i, o+2)
	poke(i, p.c, r)
	poke(i, o+2, m)
end

pci["pci-08"] = function(i, a) -- 08 slp #A : wait #A processor cycles
	s = peek(i, o)
	if s.s ~= "pci-08" then
		s = {t = "virtual", s = "pci-08", c = a}
	end
	if s.c > 0 then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 08 slp #"..DEC_HEX(a).." waiting")
		pointer = pointer - 1
		s.c = s.c - 1
	else
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 08 slp #"..DEC_HEX(a).." ending")
		s = {t = "virtual", s = "pci-00", c = 1}
	end
	poke(i, o, s)
end
pci["pci-09"] = function(i, a) -- 09 slp @A : wait @A processor cycles
	m = peek(i, a)
	s = peek(i, o)
	if s.s ~= "pci-08" then
		s = {t = "virtual", s = "pci-08", c = m.c}
	end
	if s.c > 0 then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 09 slp @"..DEC_HEX(a).." waiting")
		pointer = pointer - 1
		s.c = s.c - 1
	else
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 09 slp @"..DEC_HEX(a).." ending")
		s = {t = "virtual", s = "pci-00", c = 1}
	end
	poke(i, o, s)
end
pci["pci-0A"] = function(i, a) -- 0A yld #A : wait #A game tick
	s = peek(i, o)
	if s.s ~= "pci-0A" then
		s = {t = "virtual", s = "pci-0A", c = a}
	end
	if s.c > 1 then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0A yld #"..DEC_HEX(a).." (waiting)")
		pointer = pointer - 1
		s.c = s.c - 1
		brk = true
	elseif s.c == 1 then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0A yld #"..DEC_HEX(a).." (ending)")
		s = {t = "virtual", s = "pci-00", c = 1}
		brk = true
	else
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0A yld #"..DEC_HEX(a).." (ending)")
		s = {t = "virtual", s = "pci-00", c = 1}
	end
	poke(i, o, s)
end
pci["pci-0B"] = function(i, a) -- 0B yld @A : wait @A game tick
	m = peek(i, a)
	s = peek(i, o)
	if s.s ~= "pci-0A" then
		s = {t = "virtual", s = "pci-0A", c = m.c}
	end
	if s.c > 1 then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0A yld #"..DEC_HEX(a).." (waiting)")
		pointer = pointer - 1
		s.c = s.c - 1
		brk = true
	elseif s.c == 1 then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0A yld #"..DEC_HEX(a).." (ending)")
		s = {t = "virtual", s = "pci-00", c = 1}
		brk = true
	else
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0A yld #"..DEC_HEX(a).." (ending)")
		s = {t = "virtual", s = "pci-00", c = 1}
	end
	poke(i, o, s)
end

pci["pci-0C"] = function(i, a) -- 0C int @A : wait for modification on @A
	s = peek(i, o)
	r = peek(i, o+2)
	c = peek(i, a)
	if m.s == "pci-0C" then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0C int @"..DEC_HEX(a).." (init)")
		s = m
		pointer = pointer - 1
		poke(i, o, s)
	elseif s.t ~= m.t or s.s ~= m.s or s.c ~= m.c then
		dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0C int @"..DEC_HEX(a).." (waiting)")
		pointer = pointer - 1
	end
end
pci["pci-0D"] = function(i, a) -- 0D int &A : wait for modification on &A 
end
pci["pci-0E"] = function(i, a) -- 0E hlt #A : halt with code #A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 0E hlt "..DEC_HEX(a))
	poke(i, o, {t = "virtual", s = "pci-0E", c = a})
	brk = true
end
pci["pci-0F"] = function(i, a) -- 0F hlt @A : halt with code @A
	m = peek(i, a)
	poke(i, o, {t = "virtual", s = "pci-0E", c = m.c})
	brk = true
end

pci["pci-10"] = function(i, a) -- 10 jmp  A : jump to A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 10 jmp "..DEC_HEX(a))
	pointer = a
	poke(i, o+1, {t = "virtual", s = "pci-10", c = a})
end
pci["pci-11"] = function(i, a) -- 11 jmp @A : jump to @A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 10 jmp "..DEC_HEX(a))
	p = peek(i, a)
	pointer = p.c
	poke(i, o+1, {t = "virtual", s = "pci-10", c = p.c})
end
pci["pci-12"] = function(i, a) -- 12 rjp  A : jump relative by A
	p = peek(i, o+1)
	pointer = p.c+a
	poke(i, o+1, {t = "virtual", s = "pci-10", c = p.c+a})
end
pci["pci-13"] = function(i, a) -- 13 rjp @A : jump relative by @A
	p = peek(i, o+1)
	m = peek(i, a)
	pointer = p.c+m.c
	poke(i, o+1, {t = "virtual", s = "pci-10", c = p.c+m.c})
end
pci["pci-14"] = function(i, a) -- 14 seq  A : skip if R == A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 14 seq "..DEC_HEX(a))
	if peek(i, o+2).c == peek(i, a).c then
		pointer = pointer + 1
	end
end
pci["pci-15"] = function(i, a) -- 15 seq @A : skip if R == @A
	p = peek(i, a).c
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 15 seq @"..DEC_HEX(a))
	if peek(i, o+2).c == peek(i, p).c then
		pointer = pointer + 1
	end
end
pci["pci-16"] = function(i, a) -- 16 slt  A : skip if R < A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 14 seq "..DEC_HEX(a))
	if peek(i, o+2).c < peek(i, a).c then
		pointer = pointer + 1
	end
end
pci["pci-17"] = function(i, a) -- 17 slt @A : skip if R < @A
	p = peek(i, a).c
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 15 seq @"..DEC_HEX(a))
	if peek(i, o+2).c < peek(i, p).c then
		pointer = pointer + 1
	end
end
pci["pci-18"] = function(i, a) -- 18 sgt  A : skip if R > A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 14 seq "..DEC_HEX(a))
	if peek(i, o+2).c > peek(i, a).c then
		pointer = pointer + 1
	end
end
pci["pci-19"] = function(i, a) -- 19 sgt @A : skip if R > @A
	p = peek(i, a).c
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 15 seq @"..DEC_HEX(a))
	if peek(i, o+2).c > peek(i, p).c then
		pointer = pointer + 1
	end
end
pci["pci-1A"] = function(i, a) -- 1A snq  A : skip if R ! = A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 14 seq "..DEC_HEX(a))
	if peek(i, o+2).c ~= peek(i, a).c then
		pointer = pointer + 1
	end
end
pci["pci-1B"] = function(i, a) -- 1B snq @A : skip if R ! = @A
	p = peek(i, a).c
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 15 seq @"..DEC_HEX(a))
	if peek(i, o+2).c ~= peek(i, p).c then
		pointer = pointer + 1
	end
end
pci["pci-1C"] = function(i, a) -- 1C slq  A : skip if R < = A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 14 seq "..DEC_HEX(a))
	if peek(i, o+2).c <= peek(i, a).c then
		pointer = pointer + 1
	end
end
pci["pci-1D"] = function(i, a) -- 1D slq @A : skip if R < = @A
	p = peek(i, a).c
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 15 seq @"..DEC_HEX(a))
	if peek(i, o+2).c <= peek(i, p).c then
		pointer = pointer + 1
	end
end
pci["pci-1E"] = function(i, a) -- 1E sgq  A : skip if R > = A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 14 seq "..DEC_HEX(a))
	if peek(i, o+2).c >= peek(i, a).c then
		pointer = pointer + 1
	end
end
pci["pci-1F"] = function(i, a) -- 1F sgq @A : skip if R > = @A
	p = peek(i, a).c
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 15 seq @"..DEC_HEX(a))
	if peek(i, o+2).c >= peek(i, p).c then
		pointer = pointer + 1
	end
end
pci["pci-20"] = function(i, a) end -- 20 add  A : add R to A
pci["pci-21"] = function(i, a) end -- 21 add @A : add R to @A
pci["pci-22"] = function(i, a) -- 22 sub  A : sub R to A
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 22 sub "..DEC_HEX(a))
	r = peek(i, o+2)
	m = peek(i, a)
	m.c = m.c - r.c
	poke(i, a, m)
end
pci["pci-23"] = function(i, a) end -- 23 sub @A : sub R to @A
pci["pci-24"] = function(i, a) -- 24 inc  A : increase A by 1
	dbg_log("CALL"..tostring(i), DEC_HEX(pointer-1).." 24 inc "..DEC_HEX(a))
	m = peek(i, a)
	m.c = m.c + 1
	poke(i, a, m)
end
pci["pci-25"] = function(i, a) end -- 25 inc @A : increase @A by 1
pci["pci-26"] = function(i, a) end -- 26 dec  A : decrease A by 1
pci["pci-27"] = function(i, a) end -- 27 dec @A : decrease @A by 1
pci["pci-28"] = function(i, a) end -- 28 lsh  A : left shift A by R
pci["pci-29"] = function(i, a) end -- 29 lsh @A : left shift @A by R
pci["pci-2A"] = function(i, a) end -- 2A rsh  A : right shift A by R
pci["pci-2B"] = function(i, a) end -- 2B rsh @A : right shift @A by R
pci["pci-2C"] = function(i, a) end -- 2C ngd  A : negate A
pci["pci-2D"] = function(i, a) end -- 2D ngd @A : negate @A
pci["pci-2E"] = function(i, a) end -- 2E not  A : bitwise not A
pci["pci-2F"] = function(i, a) end -- 2F not @A : bitwise not @A
pci["pci-30"] = function(i, a) end -- 30 and  A : bitwise and A by R
pci["pci-31"] = function(i, a) end -- 31 and @A : bitwise and @A by R
pci["pci-32"] = function(i, a) end -- 32 adn  A : bitwise and A by not R
pci["pci-33"] = function(i, a) end -- 33 adn @A : bitwise and @A by not R
pci["pci-34"] = function(i, a) end -- 34 nad  A : bitwise nand A by R
pci["pci-35"] = function(i, a) end -- 35 nad @A : bitwise nand @A by R
pci["pci-36"] = function(i, a) end -- 36 ndn  A : bitwise nand A by not R
pci["pci-37"] = function(i, a) end -- 37 ndn @A : bitwise nand @A by not R
pci["pci-38"] = function(i, a) end -- 38 or   A : bitwise or A by R
pci["pci-39"] = function(i, a) end -- 39 or  @A : bitwise or @A by R
pci["pci-3A"] = function(i, a) end -- 3A orn  A : bitwise or A by not R
pci["pci-3B"] = function(i, a) end -- 3B orn @A : bitwise or @A by not R
pci["pci-3C"] = function(i, a) end -- 3C nor  A : bitwise nor A by R
pci["pci-3D"] = function(i, a) end -- 3D nor @A : bitwise nor @A by R
pci["pci-3E"] = function(i, a) end -- 3E nrn  A : bitwise nor A by not R
pci["pci-3F"] = function(i, a) end -- 3F nrn @A : bitwise nor @A by not R
pci["pci-40"] = function(i, a) end -- 40 mul  A : multiply by R in @A
pci["pci-41"] = function(i, a) end -- 41 mul @A : multiply by R in @A
pci["pci-42"] = function(i, a) end -- 42 dvf  A : floor division A by R
pci["pci-43"] = function(i, a) end -- 43 dvf @A : floor division @A by R
pci["pci-44"] = function(i, a) end -- 44 dvc  A : ceil division A by R
pci["pci-45"] = function(i, a) end -- 45 dvc @A : ceil division @A by R
pci["pci-46"] = function(i, a) end -- 46 mod @A : modulo A by R
pci["pci-47"] = function(i, a) end -- 47 mod @A : modulo @A by R
pci["pci-48"] = function(i, a) end -- 48 xor  A : bitwise xor A by R
pci["pci-49"] = function(i, a) end -- 49 xor @A : bitwise xor @A by R
pci["pci-4A"] = function(i, a) end -- 4A xrn  A : bitwise xor A by not R
pci["pci-4B"] = function(i, a) end -- 4B xrn @A : bitwise xor @A by not R
pci["pci-4C"] = function(i, a) end -- 4C nxr  A : bitwise nxor A by R
pci["pci-4D"] = function(i, a) end -- 4D nxr @A : bitwise nxor @A by R
pci["pci-4E"] = function(i, a) end -- 4E nxn  A : bitwise nxor A by not R
pci["pci-4F"] = function(i, a) end -- 4F nxn @A : bitwise nxor @A by not R
